<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 78d765903541 $
 * $Author: Marc Krämer <marc.kraemer@aldente-it.de> $
 * $Date: 2019-07-20 14:13 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_base_htmlTags{
	public const HTML = [
		'!DOCTYPE' => [],
		'?php' => [],
		'a' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onblur',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'accesskey',
				'charset',
				'coords',
				'href',
				'hreflang',
				'name',
				'rel',
				'rev',
				'shape',
				'tabindex',
				'target',
				'type',
			],
		],
		'abbr' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'acronym' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'address' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'irrelevant',
				'ref',
				'tabindex',
			],
		],
		'applet' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onload',
			],
			'norm' => [
				'align',
				'alt',
				'archive',
				'code',
				'codebase',
				'height',
				'hspace',
				'name',
				'object',
				'vspace',
				'width',
			],
		],
		'area' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
				'title',
			],
			'js' => [
				'onblur',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'accesskey',
				'alt',
				'coords',
				'href',
				'nohref',
				'shape',
				'tabindex',
				'target',
			],
		],
		'article' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'aside' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'audio' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'b' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'base' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'spellcheck',
			],
			'js' => [],
			'norm' => [
				'href',
				'target',
			],
		],
		'basefont' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
			],
			'js' => [],
			'norm' => [
				'color',
				'face',
				'size',
			],
		],
		'bdi' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'bdo' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [],
			'norm' => [],
		],
		'big' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'blockquote' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'cite',
			],
		],
		'body' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onload',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
				'onunload',
			],
			'norm' => [
				'alink',
				'background',
				'bgcolor',
				'link',
				'text',
				'vlink',
			],
		],
		'br' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [],
			'norm' => [
				'clear',
			],
		],
		'button' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onblur',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'accesskey',
				'disabled="disabled"',
				'name',
				'tabindex',
				'type',
				'value',
			],
		],
		'canvas' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'caption' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'center' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'cite' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'code' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'col' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'char',
				'charoff',
				'span',
				'valign',
				'width',
			],
		],
		'colgroup' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'char',
				'charoff',
				'span',
				'valign',
				'width',
			],
		],
		'command' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'datalist' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'dd' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'del' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'cite',
				'datetime',
			],
		],
		'details' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'dfn' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'dir' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'compact',
			],
		],
		'div' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'dl' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'compact',
			],
		],
		'dt' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'em' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'embed' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'fieldset' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'figcaption' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'figure' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'font' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [],
			'norm' => [
				'color',
				'face',
				'size',
			],
		],
		'footer' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'form' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
				'onreset',
				'onsubmit',
			],
			'norm' => [
				'accept',
				'accept-charset',
				'action',
				'enctype',
				'method',
				'name',
				'target',
			],
		],
		'frame' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [],
			'norm' => [
				'frameborder',
				'longdesc',
				'marginheight',
				'marginwidth',
				'name',
				'noresize',
				'scrolling',
				'src',
			],
		],
		'frameset' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onload',
				'onunload',
			],
			'norm' => [
				'cols',
				'rows',
			],
		],
		'h1' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'h2' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'h3' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'h4' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'h5' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'h6' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'head' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'lang',
				'spellcheck',
			],
			'js' => [],
			'norm' => [
				'profile',
			],
		],
		'header' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'hgroup' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'hr' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'noshade',
				'size',
				'width',
			],
		],
		'html' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'lang',
				'spellcheck',
			],
			'js' => [],
			'norm' => [
				'version',
			],
		],
		'i' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'iframe' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [],
			'norm' => [
				'align',
				'frameborder',
				'height',
				'longdesc',
				'marginheight',
				'marginwidth',
				'name',
				'scrolling',
				'src',
				'width',
			],
		],
		'img' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onerror',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onload',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'alt',
				'border',
				'height',
				'hspace',
				'ismap',
				'longdesc',
				'name',
				'src',
				'usemap',
				'vspace',
				'width',
			],
		],
		'input' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onblur',
				'onchange',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
				'onselect',
			],
			'norm' => [
				'accept',
				'accesskey',
				'align',
				'alt',
				'checked="checked"',
				'disabled="disabled"',
				'ismap',
				'maxlength',
				'name',
				'readonly',
				'size',
				'src',
				'tabindex',
				'type',
				'type="button"',
				'type="checkbox"',
				'type="color"',
				'type="date"',
				'type="datetime"',
				'type="datetime-local"',
				'type="email"',
				'type="file"',
				'type="hidden"',
				'type="image"',
				'type="month"',
				'type="number"',
				'type="password"',
				'type="radio"',
				'type="range"',
				'type="reset"',
				'type="search"',
				'type="submit"',
				'type="tel"',
				'type="text"',
				'type="time"',
				'type="url"',
				'type="week"',
				'usemap',
				'value',
			],
		],
		'ins' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'cite',
				'datetime',
			],
		],
		'kbd' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'keygen' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'label' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onblur',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'accesskey',
				'for',
			],
		],
		'legend' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'accesskey',
				'align',
			],
		],
		'li' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'type',
				'value',
			],
		],
		'link' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'charset',
				'href',
				'hreflang',
				'media',
				'rel',
				'rev',
				'target',
				'type',
			],
		],
		'map' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'name',
			],
		],
		'mark' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'menu' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'compact',
			],
		],
		'meta' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'lang',
				'spellcheck',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'content',
				'http-equiv',
				'name',
				'scheme',
			],
		],
		'meter' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'nav' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'noframes' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'noscript' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'object' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'archive',
				'border',
				'classid',
				'codebase',
				'codetype',
				'data',
				'declare',
				'height',
				'hspace',
				'name',
				'standby',
				'tabindex',
				'type',
				'usemap',
				'vspace',
				'width',
			],
		],
		'ol' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'compact',
				'start',
				'type',
			],
		],
		'optgroup' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'disabled="disabled"',
				'label',
			],
		],
		'option' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'disabled="disabled"',
				'label',
				'selected="selected"',
				'value',
			],
		],
		'output' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'p' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
			],
		],
		'param' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'spellcheck',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'name',
				'type',
				'value',
				'valuetype',
			],
		],
		'pre' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'width',
			],
		],
		'progress' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'q' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'cite',
			],
		],
		'rp' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'rt' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'ruby' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		's' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'samp' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'script' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'draggable',
				'dropzone',
				'hidden',
				'spellcheck',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'charset',
				'defer',
				'event',
				'for',
				'language',
				'src',
				'type',
			],
		],
		'section' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'select' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onblur',
				'onchange',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'disabled="disabled"',
				'multiple',
				'name',
				'size',
				'tabindex',
			],
		],
		'small' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'source' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'span' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'strike' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'strong' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'style' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'lang',
				'spellcheck',
				'title',
			],
			'js' => [],
			'norm' => [
				'media',
				'type',
			],
		],
		'sub' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'summary' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'sup' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'table' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'background',
				'bgcolor',
				'border',
				'cellpadding',
				'cellspacing',
				'frame',
				'rules',
				'summary',
				'width',
			],
		],
		'tbody' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'char',
				'charoff',
				'valign',
			],
		],
		'td' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'abbr',
				'align',
				'axis',
				'background',
				'bgcolor',
				'char',
				'charoff',
				'colspan',
				'headers',
				'height',
				'nowrap',
				'rowspan',
				'scope',
				'valign',
				'width',
			],
		],
		'textarea' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onblur',
				'onchange',
				'onclick',
				'ondblclick',
				'onfocus',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
				'onselect',
			],
			'norm' => [
				'accesskey',
				'cols',
				'disabled="disabled"',
				'name',
				'readonly',
				'rows',
				'tabindex',
			],
		],
		'tfoot' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'char',
				'charoff',
				'valign',
			],
		],
		'th' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'axis',
				'background',
				'bgcolor',
				'char',
				'charoff',
				'colspan',
				'headers',
				'height',
				'nowrap',
				'rowspan',
				'scope',
				'valign',
				'width',
			],
		],
		'thead' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'char',
				'charoff',
				'valign',
			],
		],
		'time' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'title' => [
			'default' => [
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'lang',
				'spellcheck',
			],
			'js' => [],
			'norm' => [],
		],
		'tr' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'align',
				'background',
				'bgcolor',
				'char',
				'charoff',
				'valign',
			],
		],
		'track' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'tt' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'u' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'ul' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [
				'compact',
				'type',
			],
		],
		'var' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'video' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
		'wbr' => [
			'default' => [
				'accesskey',
				'class',
				'contenteditable',
				'contextmenu',
				'dir',
				'draggable',
				'dropzone',
				'hidden',
				'id',
				'lang',
				'spellcheck',
				'style',
				'tabindex',
				'title',
			],
			'js' => [
				'onclick',
				'ondblclick',
				'onkeydown',
				'onkeypress',
				'onkeyup',
				'onmousedown',
				'onmousemove',
				'onmouseout',
				'onmouseover',
				'onmouseup',
			],
			'norm' => [],
		],
	];

}
