<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: e8485f0ef7ea $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-12-13 16:47 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_cache_session extends we_cache_we{
	/** @var we_cache_backend */
	protected static $cache;

	public static function setup(): void{
		if(static::$cache){
			return;
		}
		$id = 'sess_' . dechex(crc32(DB_DATABASE . DB_USER . TBL_PREFIX));
		static::$cache = we_cache_backendNone::getBackend(defined('MEMCACHE_BACKEND') ?
				(MEMCACHE_BACKEND !== we_cache_backendNone::BACKEND_DB ? MEMCACHE_BACKEND : we_cache_backendNone::BACKEND_NONE) :
				we_cache_backendNone::BACKEND_NONE, $id);
	}

	public static function save(string $entry, /* mixed */ $data, int $expiry = SYSTEM_WE_SESSION_TIME ?? 1440): bool{
		return parent::save($entry, $data, $expiry);
	}

	public static function canUseCache(): bool{
		return defined('MEMCACHE_BACKEND') && MEMCACHE_BACKEND && MEMCACHE_SERVERS && !in_array(MEMCACHE_BACKEND, [we_cache_backendNone::BACKEND_NONE, we_cache_backendNone::BACKEND_DB]);
	}

}
