<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 0a4d7404d413 $
 * $Author: Lukas Imhof $
 * $Date: 2021-11-03 14:15 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_info_object extends we_editor_base{

	protected function getContent(): we_html_multiIconBoxContent{
		return
				(new we_html_multiIconBoxContent())
				->add((new we_html_multiIconBoxContentLine('ID', (string) ($this->we_doc->ID ?: '-'), we_html_multiIconBox::PROP_META))->noline())
				->add((new we_html_multiIconBoxContentLine(g_l('weEditorInfo', '[content_type]'), g_l('weEditorInfo', '[' . $this->we_doc->ContentType . ']')))
					->space(we_html_multiIconBox::SPACE_ICON)
					->noline()
					->rightHead())
				->add((new we_html_multiIconBoxContentLine(g_l('weEditorInfo', '[creation_date]'), $this->we_doc->Creation_Date->format(g_l('weEditorInfo', '[date_format]')), we_html_multiIconBox::INFO_CALENDAR))
					->noline()
					->preline())
				->add((new we_html_multiIconBoxContentLine(g_l('modules_users', '[created_by]'), fS('SELECT CONCAT(First," ",Second," (",username,")") FROM ' . USER_TABLE . ' WHERE ID=' . intval($this->we_doc->CreatorID)) ?: '-'))
					->space(we_html_multiIconBox::SPACE_ICON)
					->noline()
					->rightHead()
					->hide(empty($this->we_doc->CreatorID))
				)
				->add((new we_html_multiIconBoxContentLine(g_l('weEditorInfo', '[changed_date]'), $this->we_doc->Mod_Date->format(g_l('weEditorInfo', '[date_format]'))))
					->space(we_html_multiIconBox::SPACE_ICON)
					->noline()
					->rightHead())
				->add((new we_html_multiIconBoxContentLine(g_l('modules_users', '[changed_by]'), fS('SELECT CONCAT(First," ",Second," (",username,")") FROM ' . USER_TABLE . ' WHERE ID=' . intval($this->we_doc->ModifierID)) ?: '-'))
					->space(we_html_multiIconBox::SPACE_ICON)
					->noline()
					->rightHead()
					->hide(empty($this->we_doc->ModifierID))
		);
	}

	public function show(): string{
		return $this->getPage((new we_html_multiIconBox($this->getContent()))->marginLeft()->get());
	}

}
