<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: e8b093d75f0d $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-01-10 12:14 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
// force the download of this document

class we_editor_other_preview extends we_editor_base{

	private function download(): string{
		$file = (file_exists(WE_DOCUMENT_ROOT . $this->we_doc->Path) ? WE_DOCUMENT_ROOT . $this->we_doc->Path : WE_DOCUMENT_ROOT . WE_SITE_DIR . $this->we_doc->Path);
		$filename = $this->we_doc->getText();
		if(file_exists($file)){
			header('Pragma: public');
			header('Expires: 0');
			header('Cache-control: private, max-age=0, must-revalidate');

			header('Content-Type: application/octet-stream');
			header('Content-Disposition: attachment; filename="' . trim(htmlentities($filename)) . '"');
			header('Content-Description: ' . trim(htmlentities($filename)));
			header('Content-Length: ' . filesize($file));
			readfile($file);
		}
		return '';
	}

	public function show(): string{
		if(we_base_request::string('we_cmd', '', 3) === 'download'){
			return $this->download();
		}
		/*$previewAvailable = false && ($this->we_doc instanceof we_document_pdf);

		if($previewAvailable && $this->we_doc->ID){ //disabled since chrome replaces whole window with this content (forcing exit of WE)
			$form = we_html_element::iframe('preview', $this->we_doc->Path);
		} else */{
			$parts = (new we_html_multiIconBoxContent())
					->add((new we_html_multiIconBoxContentLine(g_l('weClass', '[preview]'), we_html_tools::alertAttentionBox(g_l('weClass', '[no_preview_available]'), we_html_tools::TYPE_ALERT)))
					->space(we_html_multiIconBox::SPACE_MED)
			);

			if($this->we_doc->ID){
				$we_transaction = we_base_request::_(we_base_request::TRANSACTION, 'we_transaction', 0);
				$link = '<a href="' . WEBEDITION_DIR . 'we_cmd.php?we_cmd[0]=' . we_base_request::_(we_base_request::STRING, 'we_cmd', '', 0) . '&we_cmd[1]=' . we_base_request::int('we_cmd', 0, 1) . '&we_cmd[2]=' . we_base_request::_(we_base_request::STRING, 'we_cmd', '', 2) . '&we_cmd[3]=download&we_transaction=' . $we_transaction . '" download="' . $this->we_doc->Filename . '">' . $this->we_doc->getHttpPath() . "</a>";
			} else {
				$link = g_l('weClass', '[file_not_saved]');
			}
			$parts->add((new we_html_multiIconBoxContentLine(g_l('weClass', '[download]'), $link))
							->space(we_html_multiIconBox::SPACE_MED));

			$form = (new we_html_multiIconBox($parts, 'weOtherDocPrev'))->marginLeft()->get();
		}

		return $this->getPage($form, '', [
					'class' => 'weEditorBody previewOther',
					'onload' => (substr(we_base_request::string('we_cmd', '', 0), 0, 15) === 'doImage_convert' ?
					"WE().layout.we_setPath(_EditorFrame,'" . $this->we_doc->Path . "','" . $this->we_doc->getText() . "', " . intval($this->we_doc->ID) . ",'published');" : '')
		]);
	}

}
