<?php

declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 92c8600efab7 $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2022-12-19 19:00 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_editor_showTempDocumentData extends we_editor_base{

	/** @var string */
	private $file;

	/** @var bool */
	private $del = false;
	private $include = false;

	public function setContent(string $content, bool $include): self{
		$this->file = we_base_file::saveTemp($content);
		$this->del = true;
		$this->include = $include;
		return $this;
	}

	public function setFile(string $file, bool $include): self{
		$this->file = $file;
		$this->include = $include;
		return $this;
	}

	public function getFile(): string{
		return $this->file ?: '';
	}

	public function show(): string{
		if(!$this->file || !file_exists($this->file)){
			return 'file not found: ' . $this->file;
		}
		ob_start();
		if($this->include){
			include($this->file);
		} else {
			readfile($this->file);
		}
		if($this->del){
			we_base_file::deleteLocalFile($this->file);
		}
		return ob_get_clean() ?: '';
	}

}
