<?php
declare(strict_types=1);

class we_mail_mimeMultiPartRelated extends we_mail_mimePart{
	protected $mime = null;
	protected $parts = [];

	public function __construct(we_mail_mimePart $content){
		$this->type = we_mail_mime::MULTIPART_RELATED . '; type=' . $content->type;
		$this->mime = new we_mail_mime();
		$this->boundary = $this->mime->boundary();
		$this->parts[] = $content;
	}

	/**
	 * Append a new Mime_Part to the current message
	 *
	 * @param we_mail_mimePart $part
	 */
	public function addPart(we_mail_mimePart $part): void{
		/**
		 * @todo check for duplicate object handle
		 */
		$this->parts[] = $part;
	}

	public function getContent(string $EOL = we_mail_mime::LINEEND): string{
		$boundaryLine = $this->mime->boundaryLine($EOL);
		$body = '';
		foreach($this->parts as $part){
			$body .= $boundaryLine .
				$part->getHeaders($EOL) .
				$EOL .
				$part->getContent($EOL);
		}

		$body .= $this->mime->mimeEnd($EOL);
		return trim($body);
	}

}
