<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 42ff9a7c5fb6 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-12-14 00:17 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_errorJSTrigger extends we_rpc_cmd{

	function execute(): we_rpc_response{
		if(isset($_REQUEST['we_cmd']) && method_exists('we_base_errorHandler', 'log')){
			$br = we_base_browserDetect::inst();
			$line = we_base_request::int('we_cmd', 0, 'line');

			$file = we_base_request::string('we_cmd', '', 'file');
			$errobj = we_base_request::string('we_cmd', '', 'errObj');
			unset($_REQUEST['we_cmd']['file'], $_REQUEST['we_cmd']['line'], $_REQUEST['we_cmd']['errObj']);

			$_REQUEST['we_cmd']['detected'] = [
				'Browser' => $br->getBrowser() . ' ' . $br->getBrowserVersion(),
				'System' => $br->getSystem(),
			];
			$data = str_replace($_SERVER['SERVER_NAME'], 'HOST', print_r($_REQUEST['we_cmd'], true));
			unset($_REQUEST);
			we_base_errorHandler::log(we_base_errorHandler::E_JS, $data, $file, $line, true, $errobj);
		}
		return $this->resp;
	}

}
