<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev$
 * $Author$
 * $Date$
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_rpcCmd_import extends we_rpc_cmd{

	function execute(): we_rpc_response{
		switch($this->CmdShell->getCmd()){
			case 'getCSVPreview':
				return $this->getCSVPreview();
		}


		return $this->resp;
	}

	private function getCSVPreview(): we_rpc_response{
		$file = $_SESSION['weS']['module_sessions']['csvImport']['fileName'] ?? '';
		$tmplID = $_SESSION['weS']['module_sessions']['csvImport']['tmplID'] = \we_base_request::int('noDocTypeTemplateId');
		$objID = $_SESSION['weS']['module_sessions']['csvImport']['objID'] = \we_base_request::int('obj_path_id');

		$module = new we_import_wizardCSV('', 0, 0);

		$module->initCSVOptions();
		$module->initCSVParser($file);
		$html = $module->tryParseCSV($objID, $tmplID);

		if($html){
			$this->resp->setData('status', 'ok');
			$this->resp->setData('preview', $html);
			$this->resp->setData('hasDate', $module->hasDateField());
		}
		return $this->resp;
	}

}
