<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 0627c1498cde $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-02 12:07 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
//we_modules_info::isActive(we_modules_info::USERS);
define('LIVEUPDATE_DIR', WE_DOCUMENT_ROOT . '/webEdition/liveUpdate/');

class we_rpcCmd_usersPing extends we_rpc_cmd{

	function execute(): we_rpc_response{
		$LUActive = is_dir(LIVEUPDATE_DIR . 'updateClient') && is_readable(LIVEUPDATE_DIR . 'updateClient');

		$relRequest = we_users_user::updateActiveUser($LUActive, we_base_request::_(we_base_request::RAW, 'activeEditors', []));
		if($relRequest){
			$this->resp->setData('release', $relRequest);
		}
		if($LUActive){
			return $this->resp;
		}

		[$num, $usr] = we_users_online::getUsers();

		$this->resp->setData('users', $usr);
		$this->resp->setData('num_users', $num);

		$aDat = we_unserialize(we_base_preferences::getUserPref('cockpit_dat')); // array as saved in the prefs
		foreach($aDat as $d){
			if($d){
				foreach($d as $aProps){
					if($aProps[0] === 'mfd'){
						$widget = new we_widget_mfd('', $aProps);
						$this->resp->setData('mfd_data', $widget->getLastModified());
					}
				}
			}
		}
		return $this->resp;
	}

	public function cleanUp(): void{
		we_base_file::cleanTempFiles();
	}

}
