<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: f9d7b286feee $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-12-12 01:23 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_collectionSelect extends we_weTag_tag{

	/**
	 * @param array<string,mixed> $attribs parsed tag-attributes
	 * @param string $content content between openingtag and closing tag @unused-param
	 * @param bool $internal if used by we internally @unused-param
	 * @return string output to print
	 * @throws we_exception_parser if any attribute is missing
	 */
	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		if(!we_base_WE::$editmode){
			return '';
		}
		$name = self::getAttribute('name', $attribs, 0, we_base_request::STRING);
		// FIXME: why does he return when condition "!$name" is missing?
		/* 		if((!$name){self::attributeMissing($attribs, ['name' => false], __CLASS__);
		  } */
		self::$doc = we_base_WE::getWeDoc();

		$intID = self::$doc->getElementI($name) ?: self::getAttribute('id', $attribs, 0, we_base_request::INT);
		$rootDirID = 0;

		$path = id2path($intID, VFILE_TABLE);
		$textname = 'we_' . self::$doc->Name . '_collection[' . $name . '_path]';
		$idname = 'we_' . self::$doc->Name . '_collection[' . $name . '#' . we_contents_base::ETYPE_NUMBER . ']';

		$weSuggest = we_gui_suggest::getInstance();
		$weSuggest->setAcId($name . we_base_file::getUniqueId(), id2path($rootDirID,VFILE_TABLE ))
			->setContentType([we_base_ContentTypes::COLLECTION])
			->setInput($textname, $path)
			->setResult($idname, (string) ($intID))
			->setMaxResults(10)
			->setSelector(we_gui_suggest::DocSelector)
			->setTable(VFILE_TABLE)
			->setWidth(200)
			->setSelectButton(we_html_button::create_button(we_html_button::SELECT, "javascript:we_cmd('we_selector_document',{id:document.we_form.elements['" . $idname . "'].value,table:WE().consts.tables.VFILE_TABLE,targetID:'" . $idname . "',targetName:'" . $textname . "',jsCmd:'reload_hot_editpage',rootDirID:'" . $rootDirID . "',open_doc:" . (we_base_permission::hasPerm([
						we_base_perm::WORK_WORKSPACE_CAN_SELECT_OTHER_FILES]) ? 0 : 1) . "})")) //FIXME: permissions in collections
			->setOpenButton(we_html_button::create_button(we_html_button::OPEN_TO_EDIT, "javascript:if(document.forms[0].elements['" . $idname . "'].value){WE().layout.weEditorFrameController.openDocument(WE().consts.tables.VFILE_TABLE, document.forms[0].elements['" . $idname . "'].value,'');}"))
			->setTrashButton(we_html_button::create_button(we_html_button::TRASH, "javascript:document.forms[0].elements['" . $idname . "'].value=0;document.forms[0].elements['" . $textname . "'].value='';_EditorFrame.setEditorIsHot(false);we_cmd('reload_editpage');"));
		?>
		<table class="we we_collection weEditTable">
			<tr>
				<td class="bold"><?= self::getAttribute('text', $attribs, self::getAttribute('_name_orig', $attribs, '', we_base_request::STRING), we_base_request::STRING); ?></td>
				<td><?= $weSuggest->getHTML(); ?></td>
			</tr>
		</table><?php
		//FIXME: add sth. to the stack, we need an extra element in editmode
		return '';
	}

}
