<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 2fcfd49ac317 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-07-06 14:53 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_cookie extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		if(version_compare(PHP_VERSION, '7.3.0') >= 0){
			setcookie('_we_cookie_', (string) (time()), ['expires' => (time() + 630720000), 'httponly' => true, 'samesite' => 'strict']);
		} else {
			setcookie('_we_cookie_', (string) (time()), (time() + 630720000));
		}
		return '';
	}

}
