<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 74610b487d71 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2021-12-03 00:24 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifSelf extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		$obj = we_base_WE::$we_obj;
		'@phan-var we_contents_objectFile $obj';
		self::$doc = we_base_WE::getWeDoc();

		$ids = self::getAttribute('id', $attribs, [], we_base_request::INTLISTA) ?:
			[($obj ?
			$obj->ID :
			we_base_WE::$mainDoc['doc']->ID)];

		$type = self::getAttribute('doc', $attribs, self::getAttribute('type', $attribs, '', we_base_request::STRING, true), we_base_request::STRING);

		switch($type){
			case 'listview':
				switch(true){
					case (we_tag_listview::$current instanceof we_listview_listdir):
						$ids = [(($current = we_tag_listview::$current) && $current instanceof we_listview_listdir ? $current->f('id') : 0)];
						return in_array(we_tag_listview::$current->f(we_listview_base::ID_FIELD), $ids);
					case (we_tag_listview::$current instanceof we_listview_object):
					case (we_tag_listview::$current instanceof we_listview_search):
						return in_array(we_tag_listview::$current->f(we_listview_base::ID_FIELD), $ids);
					case (we_tag_listview::$current instanceof we_listview_variants):
						$tmp = we_tag_listview::$current;
						assert($tmp instanceof we_listview_variants);
						$key = $tmp->getFirstKey();
						return ($key === (self::$doc->Variant ?: $tmp->DefaultName));
					default:
						return in_array(we_tag_listview::$current->getDID(), $ids);
				}
			case 'self':
				return in_array(self::$doc->ID, $ids);
			default:
				return in_array(we_base_WE::$mainDoc['doc']->ID, $ids);
		}
	}

}
