<?php

declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 77f62e54ef7d $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2022-10-07 11:55 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_ifTemplate extends we_weTag_ifTag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): bool{
		self::$doc = we_base_WE::getWeDoc();

		$id = self::getAttribute('id', $attribs, [], we_base_request::INTLISTA);
		$TID = (self::$doc->TemplateID ?? 0);

		if($TID && $id){
			return in_array($TID, $id);
		}
		$parentid = self::getAttribute('workspaceID', $attribs, self::getAttribute('parentid', $attribs, 0, we_base_request::INT, true), we_base_request::INT);
		if($parentid){
			$curTempPath = (self::$doc instanceof we_document_webEdition ? // in documents
					str_replace(TEMPLATES_PATH, '', self::$doc->getTemplatePath()) :
					// in templates
					self::$doc->Path);
			$path = fS('SELECT DISTINCT Path FROM ' . TEMPLATES_TABLE . ' WHERE ID=' . ((int) $parentid) . ' LIMIT 1');
			return ($path && str_starts_with($curTempPath, $path));
		}
		$path = self::getAttribute('path', $attribs, '', we_base_request::FILE);

		return (!$path ||
				(self::$doc instanceof we_document_webEdition && preg_match('|^' . TEMPLATES_PATH . strtr(preg_quote($path, '|'), ['\*' => '.*']) . '$|', self::$doc->getTemplatePath())));
	}

}
