<?php

declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: d64aa040fb19 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2022-11-17 01:21 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_position extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		//	type is required !!!
		self::attributeMissing($attribs, ['type' => false], __CLASS__);

		//	here we get the needed attributes
		$format = self::getAttribute('format', $attribs, '1', we_base_request::STRING);

		switch(self::getAttribute('type', $attribs, '', we_base_request::STRING)){
			case 'listdir' : //	inside a listdir
			case 'listview' : //	inside a listview, we take direct global listview object
				return self::formatOutput($format, (we_tag_listview::$current->start + we_tag_listview::$current->count));
			case 'block' : //	look in function we_tag_block for details
				$name = self::getAttribute('_name_orig', $attribs, self::getAttribute('reference', $attribs, '', we_base_request::STRING), we_base_request::STRING);
				//	first we must get right array !!!
				self::attributeMissing($attribs, ['reference' => false], __CLASS__);
				foreach(array_reverse(we_tag_block::$position) as $arr){
					if($arr['oname'] === $name){
						return self::formatOutput($format, $arr['position']);
					}
				}
				return '';
			default:
				return '';
		}
	}

	protected static function formatOutput(string $format, int $retPos): string{
		//	convert to desired format
		switch($format){
			case 'a' :
				return we_base_util::number2System($retPos);
			case 'A' :
				return strtoupper(we_base_util::number2System($retPos));
			default:
				return (string) $retPos;
		}
	}

}
