<?php
declare(strict_types=1);

/* webEdition CMS
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_pref extends we_weTag_tag{

	/**
	 * @param array<string,mixed> $attribs parsed tag-attributes
	 * @param string $content content between openingtag and closing tag @unused-param
	 * @param bool $internal if used by we internally @unused-param
	 * @return string output to print
	 * @throws we_exception_parser if any attribute is missing
	 */
	public static function tag(array $attribs = [], string $content = '', bool $internal = false): string{
		self::attributeMissing($attribs, ['type' => false, 'name' => false], __CLASS__);
		$name = self::getAttribute('name', $attribs, '', we_base_request::STRING);

		switch(self::getAttribute('type', $attribs, '', we_base_request::STRING)){
			case 'shop':
				self::attributeMissing($attribs, ['field' => false], __CLASS__);
				$field = self::getAttribute('field', $attribs, '', we_base_request::STRING);
				switch($name){
					case 'vatRule':
						$vat = we_shop_vatRule::getShopVatRule();
						if(isset($vat->$field)){
							return is_array($vat->$field) ? implode(',', $vat->$field) : '';
						}
						break;
					case 'shippingControl':
						$ship = we_shop_shippingControl::getShippingControl();
						if(isset($ship->$field)){
							return is_array($ship->$field) ? implode(',', $ship->$field) : '';
						}
						break;
					case 'statusMails':
						$ship = we_shop_statusMails::getShopStatusMails();
						if(isset($ship->$field)){
							return is_array($ship->$field) ? implode(',', $ship->$field) : '';
						}
						break;
					case 'pref':
				}

				break;
			case 'newsletter':
				static $newsSet = false;
				$newsSet = $newsSet ?: we_newsletter_view::getSettings();
				if(isset($newsSet[$name])){
					return $newsSet[$name];
				}
				break;
		}
		t_e('pref not found in module', $attribs);
		return '';
	}

}
