<?php

declare(strict_types=1);

/* webEdition CMS
 *
 * $Rev: 983c78a3f471 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2022-11-03 01:06 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license		http://www.gnu.org/copyleft/gpl.html  GPL
 */

abstract class we_tag_sourceEntry extends we_weTag_tag{

	public static function tag(array $attribs = [], string $content = '', bool $internal = false): void{
		$id = self::getAttribute('id', $attribs, we_tag_source::$id, we_base_request::INT);
		$thumbnail = self::getAttribute('thumbnail', $attribs, '', we_base_request::STRING);
		$thumbnailid = self::getAttribute('thumbnailid', $attribs, 0, we_base_request::INT);
		$width = self::getAttribute('width', $attribs, '', we_base_request::STRING);
		if($id){
			we_tag_source::append($width, we_tag('img', ['only' => 'src',
				'id' => $id,
				'thumbnail' => $thumbnail,
				'thumbnailid' => $thumbnailid,
			]));
		}
	}

}
