<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: ed9df6e22ad8 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-23 12:35 +0100 $
 */
class we_tw_category extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);

		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::CATEGORY;

		$this->Attributes = [
			new we_weTag_textAttribute($this, 'delimiter', '', false, ''),
			new we_weTag_selectAttribute($this, 'doc', '', [
				new we_weTag_option('self'),
				new we_weTag_option('top'),
				new we_weTag_option('listview'),
				], false, ''),
			new we_weTag_selectAttribute($this, 'showpath', '', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_selectorAttribute($this, 'rootdir', '', CATEGORY_TABLE, '', false, '', true),
			new we_weTag_selectAttribute($this, 'field', '', [
				new we_weTag_option('ID'),
				new we_weTag_option('ParentID'),
				new we_weTag_option('Text'),
				new we_weTag_option('Path'),
				new we_weTag_option('Title'),
				new we_weTag_option('Description'),
				], false, ''),
			new we_weTag_textAttribute($this, 'onlyindir', ''),
			new we_weTag_selectorAttribute($this, 'id', '', CATEGORY_TABLE, ''),
			new we_weTag_textAttribute($this, 'separator', ''),
			new we_weTag_textAttribute($this, 'name', ''),
			new we_weTag_selectAttribute($this, 'multiple', '', we_weTag_selectAttribute::getTrueFalse())
		];
	}

}
