<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e9fb15a2aaef $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-15 17:36 +0100 $
 */
class we_tw_shopField extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::SHOP;

		$name = new we_weTag_textAttribute($this, 'name', '', true, '');
		$ref = new we_weTag_selectAttribute($this, 'reference', '', [
			new we_weTag_option('article'),
			new we_weTag_option('cart'),
			], true, '');
		$shopname = new we_weTag_textAttribute($this, 'shopname', '', true, '');

		$value = new we_weTag_textAttribute($this, 'value', '', false, '');
		$values = new we_weTag_textAttribute($this, 'values', '', false, '');
		$checked = new we_weTag_choiceAttribute($this, 'checked', '', we_weTag_selectAttribute::getTrueFalse(), false, false, '');
		$add = new we_weTag_choiceAttribute($this, 'mode', '', [
			new we_weTag_option('add'),], false, false, '');
		$ascountry = new we_weTag_selectAttribute($this, 'ascountry', '', we_weTag_selectAttribute::getTrueFalse());
		$aslanguage = new we_weTag_selectAttribute($this, 'aslanguage', '', we_weTag_selectAttribute::getTrueFalse());

		$this->TypeAttribute = new we_weTag_typeAttribute($this, 'type', [
			new we_weTag_option('checkbox', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('choice', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('country', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('hidden', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('language', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('print', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add, $ascountry, $aslanguage]),
			new we_weTag_option('radio', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('select', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('textarea', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			new we_weTag_option('textinput', false, '', [$name, $ref, $shopname, $value, $values, $checked, $add]),
			]
			, false, '');

		$this->Attributes = [
			$name,
			$ref,
			$shopname,
			$value,
			$values,
			$checked,
			$add,
		];
	}

}
