<?php
declare(strict_types=1);

/**

 * webEdition CMS
 *
 * $Rev: e9fb15a2aaef $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-15 17:36 +0100 $
 */
class we_tw_showShopItemNumber extends we_weTag_twbase{

	public function __construct(string $tagName){
		parent::__construct($tagName, true);
		$this->NeedsEndTag = false;
		$this->Module = we_modules_info::SHOP;

		$this->Attributes = [
			new we_weTag_textAttribute($this, 'shopname', '', true, ''),
			new we_weTag_choiceAttribute($this, 'type', '', [
				new we_weTag_option('select'),
				new we_weTag_option('textinput'),
				new we_weTag_option('print'),
				], false, false, ''),
			new we_weTag_textAttribute($this, 'start', '', false, '', '', 'number'),
			new we_weTag_textAttribute($this, 'stop', '', false, '', '', 'number'),
			new we_weTag_selectAttribute($this, 'floatquantities', '', we_weTag_selectAttribute::getTrueFalse()),
			new we_weTag_textAttribute($this, 'step', '1', false, '', '', 'number'),
			new we_weTag_choiceAttribute($this, 'num_format', '', [
				new we_weTag_option('german'),
				new we_weTag_option('french'),
				new we_weTag_option('english'),
				new we_weTag_option('swiss'),
				], false, false, ''),
		];
	}

}
