<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 2cb26206f687 $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-16 03:53 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_weTag_choiceAttribute extends we_weTag_attribute{
	/**
	 * @var array
	 */
	protected $Options;

	/**
	 * @var boolean
	 */
	protected $Multiple;

	/**
	 * @param string $name
	 * @param we_weTag_option[] $options
	 * @param boolean $required
	 */
	function __construct(we_weTag_twbase $tag, string $name, string $default, array $options = [], bool $required = false, bool $multiple = true, string $module = '', string $description = '', bool $deprecated = false){
		parent::__construct($tag, $name, $default, $required, $module, $description, $deprecated);
		$this->Options = parent::getUseOptions($options);
		$this->Multiple = $multiple;
	}

	function getCodeForTagWizard(we_html_tr $row): void{

		// get html for choice box

		$select = new we_html_select(['onchange' => ($this->Multiple ?
			'var valSel=this.options[this.selectedIndex].value; var valTa = document.getElementById(\'' . $this->getIdName() . '\').value; document.getElementById(\'' . $this->getIdName() . '\').value=((valTa==\'\' || (valSel==\'\')) ? valSel : (valTa+\',\'+valSel));' :
			'document.getElementById(\'' . $this->getIdName() . '\').value=this.options[this.selectedIndex].value;'),
			'class' => 'defaultfont selectinput'
		]);


		$entries = ['' => '----'];
		foreach($this->Options as $option){
			if($option->Value === we_html_tools::OPTGROUP){
				$select->addOptions($entries)
					->addOptionGroup(['label' => htmlentities($option->Name)]);
				$entries = [];
			} else {
				$entries[htmlspecialchars($option->Value)] = $option->getName();
			}
		}

		$select->addOptions($entries);
		$row->td($this->getLabelCodeForTagWizard(), ['class' => 'attributeName']);
		$row->td(we_html_element::input([
				'name' => $this->Name,
				'value' => $this->Value,
				'id' => $this->getIdName(),
				'class' => 'wetextinput',
				'placeholder' => $this->defaultValue,
			]), ['class' => 'attributeField']);
		$row->td($select->getHtml(), ['class' => 'attributeButton']);
		$row->td($this->defaultValue, ['class' => 'defaultValue']);
	}

}
