<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: 395527c1862b $
 * $Author: Marc Kraemer <marc.kraemer@aldente-it.de> $
 * $Date: 2020-11-17 14:35 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
class we_weTag_selectAttribute extends we_weTag_attribute{
	/** @var we_weTag_option[]	 */
	protected $Options;

	/**
	 * @param string $name
	 * @param we_weTag_option[] $options
	 * @param boolean $required
	 */
	function __construct(we_weTag_twbase $tag, string $name, string $default, array $options = [], bool $required = false, string $module = '', string $description = '', bool $deprecated = false){
		parent::__construct($tag, $name, $default, $required, $module, $description, $deprecated);
		$this->Options = parent::getUseOptions($options);
	}

	/**
	 *
	 * @staticvar boolean $tmp
	 * @param bool $reverse
	 * @return we_weTag_option[]
	 */
	static function getTrueFalse(bool $reverse = false): array{
		static $tmp = false;
		if(!$tmp){
			$tmp = [
				new we_weTag_option('true'),
				new we_weTag_option('false')
			];
		}
		return $reverse ? array_reverse($tmp) : $tmp;
	}

	function getCodeForTagWizard(we_html_tr $row): void{
		$select = new we_html_select(['name' => $this->getName(), 'id' => $this->getIdName(), 'class' => 'defaultfont selectinput']);
		if(!$this->Required){
			$select->addOption('', '');
		}

		foreach($this->Options as $option){
			$select->addOption((string) $option->Value, $option->getName(), $option->Disabled ? ['disabled' => 'disabled'] : []);
		}
		$select->selectOption($this->Value);

		$row->td($this->getLabelCodeForTagWizard(), ['class' => 'attributeName']);
		$row->td($select->getHtml(), ['class' => 'attributeField']);
		$row->td('', ['class' => 'attributeButton']);
		$row->td($this->defaultValue, ['class' => 'defaultValue']);
	}

}
