<?php
declare(strict_types=1);

/**
 * webEdition CMS
 *
 * $Rev: a248c67c654a $
 * $Author: Marc Kraemer <marc.kraemer@webedition.org> $
 * $Date: 2021-07-07 14:47 +0200 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
abstract class we_workflow_menu{

	public static function getMenu(): we_gui_menu{
		return new we_gui_menu([
				(new we_gui_menuTop(g_l('modules_workflow', '[menu][new]'), 'fa fa-plus-circle', [we_base_perm::WORKFLOW_NEW]))
				->append(new we_gui_menuEntry(g_l('modules_workflow', '[menu][new]'), ['new_workflow'], [we_base_perm::WORKFLOW_NEW])),
				(new we_gui_menuTop(g_l('modules_workflow', '[menu][workflow]'), 'fa fa-gears'))
				->set([
					new we_gui_menuEntry(g_l('modules_workflow', '[menu][save]'), ['save_workflow'], [we_base_perm::WORKFLOW_EDIT]),
					new we_gui_menuEntry(g_l('modules_workflow', '[menu][delete]'), ['delete_workflow'], [we_base_perm::WORKFLOW_DELETE]),
					new we_gui_menuSeparator(),
					new we_gui_menuEntry(g_l('modules_workflow', '[menu][empty_log]') . '&hellip;', ['empty_log'], [we_base_perm::WORKFLOW_EMPTY_LOG]),
				])
		]);
	}

}
