/* global SXE, tinyMCEPopup */

/**
 * webEdition CMS
 *
 * $Rev: 6329b796be62 $
 * $Author: Lukas Imhof $
 * $Date: 2020-11-10 16:09 +0100 $
 *
 * This source is part of webEdition CMS. webEdition CMS is
 * free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 3 of the License, or
 * any later version.
 *
 * The GNU General Public License can be found at
 * http://www.gnu.org/copyleft/gpl.html.
 * A copy is found in the textfile
 * webEdition/licenses/webEditionCMS/License.txt
 *
 * @license	http://www.gnu.org/copyleft/gpl.html  GPL
 */
'use strict';

var tinymcePlugin = window.tinyMCEPopup;

function init() {
	SXE.initElementDialog('ins');
	if (SXE.currentAction === "update") {
		setFormValue('datetime', tinymcePlugin.editor.dom.getAttrib(SXE.updateElement, 'datetime'));
		setFormValue('cite', tinymcePlugin.editor.dom.getAttrib(SXE.updateElement, 'cite'));
		SXE.disableRemoveButton(false);
	}
}

function setElementAttribs(elm) {
	setAllCommonAttribs(elm);
	setAttrib(elm, 'datetime');
	setAttrib(elm, 'cite');
	elm.removeAttribute('data-mce-new');
}

function insertIns() {
	var elm = tinymcePlugin.editor.dom.getParent(SXE.focusElement, 'INS');

	if (elm === null) {
		var s = SXE.inst.selection.getContent();
		if (s.length > 0) {
			insertInlineElement('ins');
			var elementArray = SXE.inst.dom.select('ins[data-mce-new]');
			for (var i = 0; i < elementArray.length; i++) {
				elm = elementArray[i];
				setElementAttribs(elm);
			}
		}
	} else {
		setElementAttribs(elm);
	}
	tinymcePlugin.editor.nodeChanged();
	tinymcePlugin.execCommand('mceEndUndoLevel');
}

function removeIns() {
	SXE.removeElement('ins');
}

function weTinyDialog_doOk() {
	insertIns();
	WE().util.dialogTop(window).doClose();
}

function weTinyDialog_doRemove() {
	removeIns();
	WE().util.dialogTop(window).doClose();
}

//window.tinyMCEPopup.onInit.add(init);
$(function () {
	init();
});
